'use strict'

module.exports = {
	env: {
		commonjs: true,
		es2021: true,
	},
	extends: [
		'airbnb-base',
		'plugin:prettier/recommended',
		'plugin:import/typescript',
		'plugin:@typescript-eslint/recommended',
	],
	ignorePatterns: ['dist'],
	overrides: [
		{
			env: {
				node: true,
			},
			files: ['.eslintrc.{js,cjs}'],
			parserOptions: {
				sourceType: 'script',
			},
		},
		{
			env: {jest: true},
			files: ['**/*.test.js', '**/*.test.ts'],
			plugins: ['jest'],
			rules: {
				'jest/no-disabled-tests': 'warn',
				'jest/no-focused-tests': 'error',
				'jest/no-identical-title': 'error',
				'jest/prefer-to-have-length': 'warn',
				'jest/valid-expect': 'error',
			},
		},
	],
	parser: '@typescript-eslint/parser',
	parserOptions: {
		ecmaVersion: 'latest',
		sourceType: 'module',
	},
	plugins: ['import', 'sort-imports-es6-autofix', 'jsdoc', 'sort-keys-fix', '@typescript-eslint'],
	rules: {
		'import/extensions': [
			'error',
			'ignorePackages',
			{
				js: 'never',
				jsx: 'never',
				ts: 'never',
				tsx: 'never',
			},
		],
		'import/order': 'error',
		'jsdoc/check-alignment': 1,
		'jsdoc/check-indentation': 0,
		'jsdoc/check-param-names': 0,
		'jsdoc/check-tag-names': 0,
		'jsdoc/check-types': 1,
		'jsdoc/check-values': 1,
		'jsdoc/empty-tags': 1,
		'jsdoc/implements-on-classes': 1,
		'jsdoc/match-description': 1,
		'jsdoc/newline-after-description': 0,
		'jsdoc/no-bad-blocks': 1,
		'jsdoc/no-defaults': 1,
		'jsdoc/no-undefined-types': 1,
		'jsdoc/require-description': 1,
		'jsdoc/require-description-complete-sentence': 1,
		'jsdoc/require-example': 0,
		'jsdoc/require-file-overview': 0,
		'jsdoc/require-hyphen-before-param-description': [1, 'never'],
		'jsdoc/require-jsdoc': 0,
		'jsdoc/require-param': 1,
		'jsdoc/require-param-description': 1,
		'jsdoc/require-param-name': 1,
		'jsdoc/require-param-type': 1,
		'jsdoc/require-returns': 1,
		'jsdoc/require-returns-check': 1,
		'jsdoc/require-returns-description': 1,
		'jsdoc/require-returns-type': 1,
		'jsdoc/valid-types': 1,
		'no-cond-assign': [2, 'except-parens'],
		'no-console': [1, {allow: ['error', 'info']}],
		'no-plusplus': 0,
		'no-restricted-syntax': [
			'error',
			{
				message:
					'for..in loops iterate over the entire prototype chain, which is virtually never what you want. Use Object.{keys,values,entries}, and iterate over the resulting array.',
				selector: 'ForInStatement',
			},
			{
				message: 'Labels are a form of GOTO; using them makes code confusing and hard to maintain and understand.',
				selector: 'LabeledStatement',
			},
			{
				message: '`with` is disallowed in strict mode because it makes code impossible to predict and optimize.',
				selector: 'WithStatement',
			},
		],
		'no-underscore-dangle': 0,
		'no-use-before-define': ['error', {classes: true, functions: false, variables: true}],
		radix: ['error', 'as-needed'],
		'sort-imports-es6-autofix/sort-imports-es6': 'off',
		'sort-keys-fix/sort-keys-fix': 'off',
		strict: ['error', 'global'],
		'import/prefer-default-export': 'off',
		'no-shadow': 'off',
		'@typescript-eslint/no-shadow': ['error'],
		'@typescript-eslint/no-namespace': 'off',
		'@typescript-eslint/no-unused-vars': ['warn']
	},
}
